//+------------------------------------------------------------------+
//|                                              ea_for_williams.mq4 |
//|                                                 han yi, williams |
//|                      hetachy@hotmail.com, willyjan11@yahoo.co.uk |
//+------------------------------------------------------------------+



///////////////////////////strategities////////////////////////////////////////////
// open a buy  order if  supertrend on bar 2 is red colored(value 2) and supertrend on bar 1 is green colored(value 1)..
// open a sell  order if  supertrend on bar 2 is green colored(value 1) and supertrend on bar 1 is red colored(value 2).
// A buy order must be closed if a sell signal is generated, or if the price gets to the stop loss level or  the take profit level.
// A sell order must be closed if a buy signal is generated, or if the price gets to the stop loss level or  the take profit level.
// have Trailing stop, TP, SL, and MagicNumber
///////////////////////////////////////////////////////////////////////////////////////////////  

#property copyright "han yi, williams"
#property link      "hetachy@hotmail.com, willyjan11@yahoo.co.uk"

//---- input parameters
extern double    Lots = 0.1;
extern int       MagicNumber=11111;
extern int       TP=300;
extern int       SL=50;
extern int       Slippage = 3;
extern int       TS = 50;       // trailing stop
   


 
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
      
       int cnt, order_num;
       double strend_up_1, strend_down_1, strend_up_2, strend_down_2; 
       double spread = Ask - Bid;   // to check spread for each entry
       
       bool buy_can = false;
       bool sell_can = false;
       
       
       strend_up_1 = iCustom(NULL, 0, "sa_MTEI_Supertrend",0,1);
       strend_down_1 = iCustom(NULL, 0, "sa_MTEI_Supertrend",1,1);
       strend_up_2 = iCustom(NULL, 0, "sa_MTEI_Supertrend",0,2);
       strend_down_2 = iCustom(NULL, 0, "sa_MTEI_Supertrend",1,2); 
       
      
       
       /////////////////////////Judge the entry signal/////////////////////////////////////////////////
	    if ( strend_up_1 > 0 && strend_down_1 == 0 &&  strend_down_2 > 0 )
           buy_can = true;

	    if ( strend_down_1 > 0 && strend_up_1 == 0 &&  strend_up_2 > 0 )
           sell_can = true;
       ///////////////////////////////////////////////////////////////////////////////////////////////



	   ///////////////////////Close existing order when reverse trend signal occurs ////////////
	   //////////////////////////////////and calculate order_num for this ea////////////////////
	   order_num = 0;        // the number of order of this ea             
	   for(cnt = 0; cnt < OrdersTotal(); cnt++)
       {
          OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
			 if( OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
			 {
				 order_num++;
				 if ( OrderType() == OP_BUY && sell_can)
				 {
					 OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Red);
					 order_num--;
				 } 

				 if ( OrderType() == OP_SELL && buy_can)
				 {
					 OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Red);
					 order_num--;
				 } 
			 }
	   }
	   /////////////////////////////////////////////////////////////////////////////////////////

      ///////////////////////////Trailing stop////////////////////////////////////////////////
      for (cnt = OrdersTotal(); cnt >= 0; cnt--)
      {
        OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
        if( OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
        {
           if (OrderType() == OP_SELL && TS > 0 )
           {
             if (OrderOpenPrice() - Ask >= TS * Point && OrderStopLoss() > Ask + Point * TS )
             OrderModify(OrderTicket(),OrderOpenPrice(),Ask + Point * TS,OrderTakeProfit(),0,Purple);
           }
           
           if (OrderType() == OP_BUY && TS > 0 )
           {
             if (Bid - OrderOpenPrice()  >= TS * Point && OrderStopLoss() < Bid - Point * TS )
             OrderModify(OrderTicket(),OrderOpenPrice(),Bid - Point * TS,OrderTakeProfit(),0,Purple);
           }
         }
       }  
      ///////////////////////////////////////////////////////////////////////////////////////////
      
      
	   //////////////////////////open order/////////////////////////////////////////////////////
	   if ( order_num < 1 && Volume[0] <= 1 )   // only 1 order allowed for this ea and only open at the begin of a bar
	   {
		   if (buy_can)
		   {
			   OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,Ask - spread - SL*Point, Ask + TP*Point,"",MagicNumber,0,Blue);
			   buy_can = false; // avoid entering the trade twice in the same bar
		   }

		   if (sell_can)
		   {
			   OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,Bid + spread + SL*Point, Bid - TP*Point,"",MagicNumber,0,Blue);
			   sell_can = false; // avoid entering the trade twice in the sam bar
		   }
	   }
	   ////////////////////////////////////////////////////////////////////////////////////////////////
//----
   return(0);
  }
//+------------------------------------------------------------------+